<template>
  <div :class="classes" ref="wrapper">
    <div class="conveyor">
      <span
        class="tag-item"
        v-for="tag in value"
        :key="String(tag.value)"
        :style="tagStyles"
      >
        <tag
          @click="$emit('click', tag)"
          :label="tag.label"
          :fullwidth="Boolean(tagWidth)"
          :actived="tag.actived"
        />
      </span>
    </div>
  </div>
</template>

<script>
import Tag from "./Tag";
import BScroll from "better-scroll";
import wheel from "@/lib/better-scroll-vertical-wheel";

export default {
  props: {
    value: Array,
    scroll: Boolean,
    fullwidth: Boolean,
    tagWidth: String,
    tagMaxWidth: String
  },

  components: {
    Tag
  },

  computed: {
    tagStyles() {
      const styles = {};
      if (this.tagWidth) {
        styles.width = this.tagWidth;
      }
      if (this.tagMaxWidth) {
        styles.maxWidth = this.tagMaxWidth;
      }
      return styles;
    },

    classes() {
      return {
        tags: true,
        scroll: this.scroll,
        flex: Boolean(this.flexWidth),
        fullwidth: this.fullwidth
      };
    }
  },

  methods: {
    enableScroll() {
      this.timesScroll = wheel(
        new BScroll(this.$refs.wrapper, {
          scrollX: true,
          click: true,
          eventPassthrough: "vertical"
        })
      );
    }
  },

  mounted() {
    this.$nextTick(() => {
      if (this.scroll) {
        this.enableScroll();
      }
    });
  },

  destroyed() {
    this.timesScroll && this.timesScroll.destroy();
  }
};
</script>

<style lang="scss" scoped>
.tags {
  position: relative;

  .tag-item {
    display: inline-block;
    padding: 0 10px 10px 0;
  }

  &.scroll {
    white-space: nowrap;
    cursor: grab;
    user-select: none;
    display: inline-block;

    .conveyor {
      display: inline-block;
    }

    &:after {
      content: "";
      background: linear-gradient(
        to left,
        $color-white 0%,
        rgba(255, 255, 255, 0) 100%
      );
      position: absolute;
      top: 0;
      right: 0;
      height: 100%;
      width: 100px;
      pointer-events: none;
    }

    &:before {
      content: "";
    }
  }

  &.dragging {
    cursor: grabbing;
  }

  &.fullwidth {
    width: 100%;
    overflow: hidden;
  }
}
</style>
